#include <NTDDK.H>
#include <windef.h>
#include "LDasm.h"

#define NT_DEVICE_NAME					L"\\Device\\CallHookPsLookupXXX"
#define DOS_DEVICE_NAME					L"\\DosDevices\\CallHookPsLookupXXX"

#define IOCTL_BASE	0x800

#define MY_CTL_CODE(i) \
	CTL_CODE(FILE_DEVICE_UNKNOWN, IOCTL_BASE+i, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_StartProt		MY_CTL_CODE(1) //Start to Protect
#define IOCTL_StopProt		MY_CTL_CODE(2) //Stop Protection
#define IOCTL_SetPID		MY_CTL_CODE(3) //Set PID

typedef struct _System_Service_Table{   //SSDTṹ
	PVOID  ServiceTableBase; 
	PVOID  ServiceCounterTableBase; 
	ULONG  NumberOfServices; 
	PVOID  ParamTableBase; 
} SYSTEM_SERVICE_TABLE, *PSYSTEM_SERVICE_TABLE;

NTKERNELAPI PEPROCESS IoThreadToProcess (IN PETHREAD Thread);
extern  PSYSTEM_SERVICE_TABLE KeServiceDescriptorTable;
PEPROCESS ProtectedProcess;//ҪĽ̶

typedef NTSTATUS (*PSLOOKUPPROCESSBYPROCESSID)
(
 IN ULONG ProcessID,
 OUT PEPROCESS *Process
);

typedef NTSTATUS (*PSLOOKUPTHREADBYTHREADID)
(
 IN ULONG ThreadID,
 OUT PETHREAD *Thread
);

typedef NTSTATUS (*NTOPENPROCESS)
(
	OUT PHANDLE ProcessHandle,
	IN ACCESS_MASK AccessMask,
	IN POBJECT_ATTRIBUTES ObjectAttributes,
	IN PCLIENT_ID ClientId
);

typedef NTSTATUS (*NTOPENTHREAD)
(
	OUT	PHANDLE ThreadHandle,
	IN	ACCESS_MASK DesiredAccess,
	IN	POBJECT_ATTRIBUTES ObjectAttributes,
	IN	PCLIENT_ID ClientId
);

PSLOOKUPPROCESSBYPROCESSID		PsLookupProcessByProcessId=NULL;
PSLOOKUPTHREADBYTHREADID		PsLookupThreadByThreadId=NULL;
NTOPENPROCESS					pNtOpenProcess=NULL,ZwOpenProcess=NULL;
NTOPENTHREAD					pNtOpenThread=NULL,ZwOpenThread=NULL;
PVOID							Sj1=NULL,Sj2=NULL;
BYTE							SjBytes[6]={0x68,0,0,0,0,0xC3};
ULONG IndexOf_NtOpenProcess;
ULONG IndexOf_NtOpenThread;
KIRQL f_oldirql;
KSPIN_LOCK f_spinlock;

NTSTATUS fake_PsLookupProcessByProcessId(IN ULONG ProcessId,OUT PEPROCESS *Process)
{
	NTSTATUS st;
	PEPROCESS txps;
	st=PsLookupProcessByProcessId(ProcessId,&txps);
	if(txps==ProtectedProcess)
	{
		st=0xC0000022;
	}
	else
	{
		st=PsLookupProcessByProcessId(ProcessId,Process);
	}
	return st;
}

NTSTATUS fake_PsLookupThreadByThreadId(IN ULONG ThreadId,OUT PETHREAD *Thread)
{
	NTSTATUS st;
	PETHREAD txtd;
	PEPROCESS txps;
	st=PsLookupThreadByThreadId(ThreadId,&txtd);
	txps=IoThreadToProcess(txtd);
	if(txps==ProtectedProcess)
	{
		st=0xC0000022;
	}
	else
	{
		st=PsLookupThreadByThreadId(ThreadId,Thread);
	}
	return st;
}

// StartAddrַ ʼOldAddr 滻ΪNewAddrַ
BOOL CallAddrHook(PVOID StartAddr,PVOID OldAddr,PVOID NewAddr)
{
	PUCHAR cPtr, pOpcode;
	ULONG Length,Tmp;
	PMDL pMdl;
	for (cPtr=StartAddr;(ULONG)cPtr<(ULONG)StartAddr+0x1000;cPtr += Length)
	{
		Length = SizeOfCode(cPtr, &pOpcode);//㵱ǰָ
		if (!Length) break;
		if (Length ==5 && *cPtr==0xE8)// ǰ5 ҵһֽΪE8 
		{//ΪCALLõƫ  ǻҪмƫ
			if ( (ULONG)OldAddr-(ULONG)cPtr-5 == *(PULONG)(cPtr+1)) //жϵǰǷΪOldAddrCALLԵַ 
			{
				Tmp=(ULONG)NewAddr-(ULONG)cPtr-5;//ǵCALLַƫ
				pMdl=IoAllocateMdl((PVOID)(cPtr+1),4,FALSE,FALSE,NULL);
				if(pMdl)
				{
					__try
					{
						MmProbeAndLockPages(pMdl,KernelMode,IoWriteAccess);
					}
					__except(EXCEPTION_EXECUTE_HANDLER)
					{
						IoFreeMdl(pMdl);
					}
					//HOOK
					f_oldirql=KeRaiseIrqlToDpcLevel();
					KeInitializeSpinLock(&f_spinlock);
					KeAcquireSpinLockAtDpcLevel(&f_spinlock);
					__asm 
					{   
						cli
						mov  eax,cr0
						and  eax,not 10000h
						mov  cr0,eax
					}
					InterlockedExchange((PULONG)(cPtr+1),Tmp);//ֱ滻ΪǵFAKEַ   
					__asm
					{    
						mov  eax,cr0
						or   eax,10000h
						mov  cr0,eax
						sti
					} 
					KeReleaseSpinLockFromDpcLevel(&f_spinlock);
					KeLowerIrql(f_oldirql);
					IoFreeMdl(pMdl);
					return TRUE;
				}
			}
		}
	}
	return FALSE;
}

ULONG GetSSDTCurAddr(IN ULONG Index)
{
	ULONG ServiceCount,BaseAddr;
	if (KeServiceDescriptorTable!=NULL)
	{
		ServiceCount=KeServiceDescriptorTable->NumberOfServices;
		BaseAddr = (ULONG)KeServiceDescriptorTable->ServiceTableBase;

		if (Index>=ServiceCount) return FALSE;

		return *(PULONG)(BaseAddr+Index * 4);
	}
	return FALSE;
}

void StartHook()
{
	//deal with NTKERNELAPI
	UNICODE_STRING uniFuncName1;
	UNICODE_STRING uniFuncName2;
	UNICODE_STRING uniFuncName3;
	UNICODE_STRING uniFuncName4;
	RtlInitUnicodeString(&uniFuncName1,L"PsLookupProcessByProcessId");
	RtlInitUnicodeString(&uniFuncName2,L"PsLookupThreadByThreadId");
	RtlInitUnicodeString(&uniFuncName3,L"ZwOpenProcess");
	RtlInitUnicodeString(&uniFuncName4,L"ZwOpenThread");
	PsLookupProcessByProcessId=MmGetSystemRoutineAddress(&uniFuncName1);
	PsLookupThreadByThreadId=MmGetSystemRoutineAddress(&uniFuncName2);
	ZwOpenProcess=MmGetSystemRoutineAddress(&uniFuncName3);
	ZwOpenThread=MmGetSystemRoutineAddress(&uniFuncName4);
	//deal with SSDT Function
	RtlCopyMemory(&IndexOf_NtOpenProcess,(PVOID)((ULONG)ZwOpenProcess+1),4);
	RtlCopyMemory(&IndexOf_NtOpenThread,(PVOID)((ULONG)ZwOpenThread+1),4);
	pNtOpenProcess=(PVOID)GetSSDTCurAddr(IndexOf_NtOpenProcess);
	pNtOpenThread=(PVOID)GetSSDTCurAddr(IndexOf_NtOpenThread);
	//deal with second jump
	*(PULONG)((ULONG)&SjBytes+1)=(ULONG)fake_PsLookupProcessByProcessId;
	Sj1=ExAllocatePool(NonPagedPool,6);
	RtlCopyMemory(Sj1,&SjBytes,6);
	*(PULONG)((ULONG)&SjBytes+1)=(ULONG)fake_PsLookupThreadByThreadId;
	Sj2=ExAllocatePool(NonPagedPool,6);
	RtlCopyMemory(Sj2,&SjBytes,6);
	//Start to Hook
	CallAddrHook(pNtOpenProcess,PsLookupProcessByProcessId,Sj1);
	CallAddrHook(pNtOpenThread,PsLookupThreadByThreadId,Sj2);
}

void StopHook()
{
	CallAddrHook(pNtOpenProcess,Sj1,PsLookupProcessByProcessId);
	CallAddrHook(pNtOpenThread,Sj2,PsLookupThreadByThreadId);
	//deal with second jump
	ExFreePool(Sj1);
	ExFreePool(Sj2);
}