#include <NTDDK.H>
#include "Hook.h"

NTSTATUS DriverEntry(IN PDRIVER_OBJECT DriverObject, IN PUNICODE_STRING RegistryPath);
NTSTATUS DispatchCreateClose(IN PDEVICE_OBJECT pDevObj,IN PIRP pIrp);
NTSTATUS DispatchIoctl(IN PDEVICE_OBJECT pDevObj,IN PIRP pIrp);
VOID UnloadDriver(IN PDRIVER_OBJECT DriverObject );

NTSTATUS DriverEntry(IN PDRIVER_OBJECT DriverObject,IN PUNICODE_STRING RegistryPath)
{

	UNICODE_STRING   uniDeviceName;
	UNICODE_STRING   uniSymLink;
	NTSTATUS         ntStatus;
	PDEVICE_OBJECT   deviceObject = NULL;

	RtlInitUnicodeString(&uniDeviceName, NT_DEVICE_NAME);
	RtlInitUnicodeString(&uniSymLink, DOS_DEVICE_NAME);

	DriverObject->MajorFunction[IRP_MJ_CREATE] = 
		DriverObject->MajorFunction[IRP_MJ_CLOSE] = DispatchCreateClose;
	DriverObject->MajorFunction[IRP_MJ_DEVICE_CONTROL] = DispatchIoctl;
	DriverObject->DriverUnload = UnloadDriver;

	ntStatus = IoCreateDevice(DriverObject, 0,&uniDeviceName,FILE_DEVICE_UNKNOWN,FILE_DEVICE_SECURE_OPEN, FALSE,&deviceObject);

	if (!NT_SUCCESS(ntStatus)) return ntStatus;

        ntStatus = IoCreateSymbolicLink(&uniSymLink, &uniDeviceName);

	if (!NT_SUCCESS(ntStatus))
	{
		IoDeleteDevice(deviceObject);
		return ntStatus;
	}
	
	//DbgPrint("driver loaded!\n");
    return STATUS_SUCCESS;
}

NTSTATUS DispatchCreateClose(IN PDEVICE_OBJECT pDevObj, IN PIRP pIrp)
{
	pIrp->IoStatus.Information = 0;
	pIrp->IoStatus.Status = STATUS_SUCCESS;
	IoCompleteRequest(pIrp, IO_NO_INCREMENT);
	return STATUS_SUCCESS;
}

NTSTATUS DispatchIoctl(IN PDEVICE_OBJECT pDevObj,IN  PIRP pIrp)
{
	
	NTSTATUS ntStatus = STATUS_INVALID_DEVICE_REQUEST;//STATUS_UNSUCCESSFUL;//
	PIO_STACK_LOCATION pIrpStack = IoGetCurrentIrpStackLocation(pIrp);
	ULONG uIoControlCode = pIrpStack->Parameters.DeviceIoControl.IoControlCode;
	ULONG inBufLength = pIrpStack->Parameters.DeviceIoControl.InputBufferLength;
	ULONG outBufLength =pIrpStack->Parameters.DeviceIoControl.OutputBufferLength;
	PVOID OutputBuffer = pIrp->UserBuffer;
	PVOID InputBuffer  = pIrp->AssociatedIrp.SystemBuffer;
	
	switch(uIoControlCode)
	{
	case IOCTL_StartProt:
		{
			ProtectedProcess=PsGetCurrentProcess();
			StartHook();
			break;
		}
	case IOCTL_StopProt:
		{
			StopHook();
			ProtectedProcess=NULL;
			break;
		}
	case IOCTL_SetPID:
		{
			PsLookupProcessByProcessId(*(PULONG)InputBuffer,&ProtectedProcess);
			break;
		}
	}
	
	pIrp->IoStatus.Status = ntStatus;
	//pIrp->IoStatus.Information = outBufLength;
	IoCompleteRequest(pIrp, IO_NO_INCREMENT);
	return ntStatus;
}

VOID UnloadDriver( IN PDRIVER_OBJECT DriverObject )
{
	PDEVICE_OBJECT    deviceObject = DriverObject->DeviceObject;
	UNICODE_STRING    uniSymLink;
	RtlInitUnicodeString(&uniSymLink, DOS_DEVICE_NAME);
	
	//DbgPrint("driver unloaded.\n");
	IoDeleteSymbolicLink(&uniSymLink);
	IoDeleteDevice(deviceObject);
}